apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ squid_name }}
  name: {{ squid_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ squid_replicas }}
  selector:
    matchLabels:
      name: {{ squid_name }}
  template:
    metadata:
      labels:
        name: {{ squid_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ squid_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ squid_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='squid'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 26
          tcpSocket:
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 4
        name: squid
        ports:
        - containerPort: 8080
        readinessProbe:
          tcpSocket:
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 4
        resources:
          limits:
            cpu: {{ squid_cpu_limit }}
            memory: {{ squid_memory_limit }}
          requests:
            cpu: {{ squid_cpu_request }}
            memory: {{ squid_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/squid/nocache.acl
          name: config
          subPath: nocache.acl
        - mountPath: /var/run
          name: tmp
        - mountPath: /var/spool/squid
          name: data
          subPath: spool
{% if do_exporters %}
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: SQUID_EXPORTER_LISTEN
          value: ":9113"
        - name: SQUID_PORT
          value: "8080"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='squidexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if k8s_flavor == 'kubernetes' and do_exporters %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
      terminationGracePeriodSeconds: {{ squid_termination_timeout | default(60) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ squid_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          name: {{ squid_name }}
        name: config
      - emptyDir: {}
        name: tmp
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: {{ squid_data_capacity }}
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
